config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :committees do
    match 'trials', to: 'trials#clear_permitted_trials', via: :delete, as: 'trial_clear_permitted'
    resources :trials do
      match 'state/:state_id', to: 'trials#set_state', via: :patch, as: 'set_state'
      match 'authorize/:private_key_digest', to: 'trials#receive_private_key_digest', via: :get,
                                             as: :authorize
      match '', to: 'trials#receive_private_key', via: :post
      match 'versions', to: 'trials#versions', via: :get
      match 'versions', to: 'trials#delete_versions', via: :delete
      match 'comment', to: 'trials#comment', via: :post
      resources :tasks, only: [:create, :update, :destroy, :edit]
      post 'upload', to: 'trials#upload'
    end
    resources :ranks, only: [:create, :destroy]
    resources :environments, only: [:create, :destroy, :edit, :update]
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get
  match 'permitted_keywords' => 'home#permitted_keywords', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/committee.rb
# frozen_string_literal: true
class Committee < ApplicationRecord
  # t.string   "name",                                 null: false
  # t.datetime "created_at",                           null: false
  # t.datetime "updated_at",                           null: false
  # t.string   "formsub_committee_id"
  # t.integer  "overdue_state_id"
  # t.integer  "positive_finish_state_id"
  # t.integer  "negative_finish_state_id"
  # t.integer  "min_trial_tasks_count",    default: 5, null: false
  # t.string   "drive_token"
  # t.string   "drive_root"
  # t.text     "formal_conditions"
  # t.index ["name"], name: "index_committees_on_name", unique: true, using: :btree

  # validations
  validates :name, presence: true, uniqueness: true
  # validates :stateman, presence: true
  validates :min_trial_tasks_count, presence: true

  # relations
  has_many :trials, dependent: :restrict_with_exception
  has_one :stateman, dependent: :destroy
  has_many :ranks, dependent: :restrict_with_exception
  has_many :environments, dependent: :restrict_with_exception
  has_many :comments, dependent: :restrict_with_exception

  # callbacks
  after_create :create_stateman_resources
  after_save :create_formsub_resource, unless: :formsub_committee_id?

  # rest instance methods
  attr_reader :drive_token_raw
  attr_writer :redirection

  def formsub_committee
    FormsubCommittee.find(formsub_committee_id)
  end

  def finish_state_ids
    [positive_finish_state_id, negative_finish_state_id]
  end

  def drive_token_raw=(token_raw)
    update(drive_token: nil, drive_root: nil) && return if token_raw.empty?
    drive = GoogleDrive.new(self)
    drive.authorize(token_raw)
  end

  def drive
    @drive ||= GoogleDrive.new(self)
  end

  def drive_configured?
    drive_root.present? && drive_token.present?
  end

  def redirection
    @redirection || self
  end

  private

  def create_stateman_resources
    organization = StatemanOrganization.create(name: name)
    create_stateman(organization_id: organization.id) if organization.save

    return if stateman.trials_created?

    stateman.update(trials_created: StatemanItemType.create(
      title: 'trials', organization_id: organization.id, post_service: 'TrialsItemsTypePopulator'
    ))
  end

  def create_formsub_resource
    committee = FormsubCommittee.create(name: name, zaki_committee_id: id)
    update(formsub_committee_id: committee.id) if committee.save
  end

  def stateman_present?
    stateman.present?
  end
end

app/controllers/committees_controller.rb
# frozen_string_literal: true

require 'google_drive'

class CommitteesController < ApplicationController
  prepend_before_action :set_committee, only: [:show, :edit, :update, :destroy]
  skip_before_action :login_required, only: :show
  before_action :set_committees, only: [:index, :edit]

  # GET /committees
  # GET /committees.json
  def index
    redirect_to @committees.first if @committees.one?
  end

  # GET /committees/1
  # GET /committees/1.json
  def show
    @state_trial_count = StatemanTrial.get(:summary,
                                           organization_id: @committee.stateman.organization_id,
                                           id: 'trials')
  end

  # GET /committees/new
  def new
    @committee = Committee.new
  end

  # GET /committees/1/edit
  def edit
    set_edit_instance_variables
    @drive = GoogleDrive.new(@committee)
    @root_dir_name = root_dir_name if @committee.drive_configured?
  end

  # POST /committees
  # POST /committees.json
  def create
    @committee = Committee.new(committee_params)

    respond_to do |format|
      if @committee.save
        format.html { redirect_to @committee, notice: t(:committee_successfully_created) }
        format.json { render :show, status: :created, location: @committee }
      else
        format.html { render :new }
        format.json { render json: @committee.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /committees/1
  # PATCH/PUT /committees/1.json
  def update
    set_edit_instance_variables
    respond_to do |format|
      if @committee.update(committee_params)
        format.html do
          redirect_to @committee.redirection, notice: t(:committee_successfully_updated)
        end
        format.json { render :show, status: :ok, location: @committee }
      else
        format.html { render :edit }
        format.json { render json: @committee.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /committees/1
  # DELETE /committees/1.json
  def destroy
    @committee.destroy
    respond_to do |format|
      format.html { redirect_to committees_url, notice: t(:committee_successfully_destroyed) }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_committee
    @committee = Committee.find(params[:id])
  end

  def authorize_committee
    authorize @committee || Committee
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def committee_params
    params.require(:committee).permit(:name, :overdue_state_id, :positive_finish_state_id,
                                      :negative_finish_state_id, :min_trial_tasks_count,
                                      :drive_token_raw, :drive_root, :formal_conditions, :info,
                                      :redirection)
  end

  def set_edit_instance_variables
    @states = @committee.stateman.organization.stateman_states
    @ranks = @committee.ranks
    @rank = Rank.new
    @environment = Environment.new
    @environments = @committee.environments
  end

  def set_committees
    @committees = policy_scope(Committee)
  end

  def root_dir_name
    @drive.authorized.get_filename(@committee.drive_root)
  end
end

app/helpers/committees_helper.rb
# frozen_string_literal: true
module CommitteesHelper
  def folders
    @drive.authorized.find_folders_by_name(params[:drive_root]).files.collect { |f| [f.name, f.id] }
  end

  def stateman_url(commitee)
    Rails.application.secrets.stateman_url + '/organizations/' + commitee.stateman.organization_id
  end

  def formal_condition_value
    return nil if @committee.formal_conditions.blank?
    @committee.formal_conditions.lines.each(&:squish!).join("\n")
  end

  def drive_root_url(commitee)
    'https://drive.google.com/drive/u/0/folders/' + commitee.drive_root
  end
end

app/views/committees/_form.html.haml
= form_for committee do |f|
  - if committee.errors.any?
    .container-fluid
      .col-lg-10.offset-lg-1
        .card.card-outline-danger#error-explanation
          .card-block
            %h4
              = t('errors', count: committee.errors.count)
              = t('error_message', count: committee.errors.count)
            %ul.list-group
              - committee.errors.full_messages.each do |msg|
                %li.list-group-item= msg
    .ls40

  .field.form-group
    = f.label :name
    = f.text_field :name, class: 'form-control'
  .field.form-group
    = f.label :min_trial_tasks_count
    = f.number_field :min_trial_tasks_count, class: 'form-control'
  - unless action_name == 'new' || action_name == 'create'
    .field.form-group
      = f.label :overdue_state_id
      = f.select :overdue_state_id, states.collect { |s| [s.name, s.id] },
      { include_blank: true }, class: 'custom-select form-control'
    .field.form-group
      = f.label :positive_finish_state_id
      = f.select :positive_finish_state_id,
      states.collect { |s| [s.name, s.id] },
      { include_blank: true }, class: 'custom-select form-control'
    .field.form-group
      = f.label :negative_finish_state_id
      = f.select :negative_finish_state_id,
      states.collect { |s| [s.name, s.id] },
      { include_blank: true }, class: 'custom-select form-control'
    .field.form-group
      = f.label :formal_conditions
      = f.text_area :formal_conditions, class: 'form-control',
      value: formal_condition_value
      %small.form-text.text-muted
        = t('committee_form.formal_conditions.description')
    .field.form-group
      = f.label :info
      %hr
      = f.trix_editor :info
      %small.form-text.text-muted
        = t('committee_form.info.description')
      %hr
  .actions.d-inline-block.float-right
    = f.submit t(:save), class: 'btn btn-success'

app/views/committees/edit.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs', locals: { final_title: t(:edit) }

= render 'shared/alerts'
.row
  .col-md-8.offset-md-2.col-xl-6.offset-xl-3
    .ls60
    %h2= t(:edit_committee)
    %hr
    - if current_user.admin?
      .col-md-6.offset-md-3
        = link_to t(:edit_states), stateman_url(@committee),
        target: '_blank', class: 'btn btn-primary btn-block'
      %hr
    = render 'form', committee: @committee, states: @states

    = link_to t(:back), committees_path, class: 'btn btn-secondary'

    .ls60
    %h2= t(:edit_committee_ranks)
    %hr

    %ul.list-group
      - @ranks.each do |rank|
        %li.list-group-item.show-on-hover-parent
          .col-lg-11.col-sm-10
            .btn-sm= rank.name
          .col-lg-1.col-sm-2.show-on-hover= link_to t(:delete),
          [@committee, rank], method: :delete, class: 'btn btn-sm btn-warning'

      %li.list-group-item
        = form_for [@committee, @rank], html: { class: 'form-inline' } do |f|
          = f.label :name, class: 'sr-only'
          .input-group
            .input-group-addon= t(:add_rank)
            = f.text_field :name, class: 'form-control'
            .input-group-addon
              = f.submit t(:add), class: 'btn btn-sm'

    .ls60
    %h2= t(:edit_committee_environments)
    %hr

    %ul.list-group
      - @environments.each do |environment|
        %li.list-group-item.show-on-hover-parent
          .col-lg-10.col-md-6.col-sm-8
            .btn-sm
              = environment.name
              (#{environment.supervisor_name || t(:no_supervisor)})
          .col-lg-1.col-md-3.col-sm-2.show-on-hover= link_to t(:edit), [:edit,
          @committee, environment], class: 'btn btn-sm btn-secondary'
          .col-lg-1.col-md-3.col-sm-2.show-on-hover= link_to t(:delete),
          [@committee, environment], method: :delete,
          class: 'btn btn-sm btn-warning'

      %li.list-group-item
        = form_for [@committee, @environment],
        html: { class: 'form-inline' } do |f|
          = f.label :name, class: 'sr-only'
          .input-group
            .input-group-addon= t(:add_environment)
            = f.text_field :name, class: 'form-control'
            .input-group-addon
              = f.submit t(:add), class: 'btn btn-sm'

    .ls60
    %h2
      %a#edit-committee-drive= t(:edit_committee_drive)
    %hr

    - if Rails.application.secrets.google_client_id.present?
      - if @committee.drive_token?
        .btn-group-vertical.float-right
          = form_for @committee do |f|
            = f.hidden_field :drive_token_raw, value: ''
            = f.hidden_field :drive_root, value: ''
            = f.submit t(:delete_drive), class: 'btn btn-danger',
            data: { confirm: t(:confirm_delete_drive_root) }
          = link_to t(:open_dir), drive_root_url(@committee),
          class: 'btn btn-info', target: '_blank'
        %p= t(:drive_configured)
        - if @committee.drive_root?
          %p= t(:drive_root_configured, dir: @root_dir_name)
        .ls40
        - unless @committee.drive_root?
          - if params[:drive_root].present?
            = form_for @committee, html: { class: 'field_with_errors' } do |f|
              %h5= f.label :drive_root
              .input-group
                = f.select :drive_root, folders, {},
                class: 'form-control custom-select'
                .btn-group
                  = f.submit t(:save), class: 'btn btn-primary'
                  = link_to t(:back), edit_committee_path(@committee,
                  anchor: 'edit-committee-drive'), class: 'btn btn-secondary'
          - else
            %form.field_with_errors
              %h5= label_tag :drive_root, t(:drive_root)
              .input-group
                = text_field_tag :drive_root, '', class: 'form-control'
                = submit_tag t(:search), class: 'btn btn-primary'
      - else
        .hidden#add-drive-input
          = form_for @committee, html: { class: 'field_with_errors' } do |f|
            .input-group
              = f.hidden_field :redirection,
              value: edit_committee_path(@committee,
              anchor: 'edit-committee-drive')
              = f.text_field :drive_token_raw, placeholder: t(:put_token_here),
              class: 'form-control'
              = f.submit t(:save), class: 'btn btn-primary'
        = link_to t(:add_drive), @drive.authorization_url, target: '_blank',
        class: 'btn btn-primary', id: 'add-drive-button'
      :javascript
        $('#add-drive-button').click(function(e) {
          $(this).css('display', 'none');
          $('#add-drive-input').css('display', 'initial');
        });
    - else
      You need to set up GOOGLE_CLIENT_ID env var to use google drive.

app/views/committees/index.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:listing_committees) }

  - if current_user.admin?
    = render 'shared/additional_menu' do
      = link_to new_committee_path,
      class: 'nav-link btn btn-success' do
        %i.fa.fa-plus-square-o
        %span= t(:new_committee)

= render 'shared/alerts'

.col-md-6.offset-md-3
  %table.table
    %thead
      %tr
        %th= t(:name)
        %th

    %tbody
      - @committees.each do |committee|
        %tr
          %td= link_to committee.name, committee
          %td
            .btn-group
              = link_to t(:edit), edit_committee_path(committee),
              class: 'btn btn-secondary'
              - if current_user.admin?
                = link_to t(:destroy), committee, class: 'btn btn-warning',
                method: :delete, data: { confirm: t(:confirm_delete) }

app/views/committees/new.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:new_committee) }

.row
  .col-md-4.offset-md-4
    = render 'form', committee: @committee

    = link_to t(:back), committees_path, class: 'btn btn-secondary'

app/views/committees/show.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs', locals: { final_title: t(:trials) }

  = render 'shared/additional_menu' do
    = link_to new_committee_trial_path(@committee),
    class: 'btn btn-success' do
      %i.fa.fa-plus-square-o
      %span= t(:new_trial)
    - if policy(@committee).edit?
      = link_to edit_committee_path(@committee), class: 'btn btn-secondary',
      title: t(:edit_committee), 'data-toggle': 'tooltip',
      'data-placement': 'bottom' do
        %i.fa.fa-edit
        %span.hidden-sm-up= t(:edit_committee)
      - if current_user.admin?
        = link_to @committee,
        method: :delete, data: { confirm: t(:confirm_delete) },
        class: 'btn btn-danger', title: t(:delete_committee),
        'data-toggle': 'tooltip', 'data-placement': 'bottom',
        'data-offset': '0 25' do
          %i.fa.fa-trash-o
          %span.hidden-sm-up= t(:delete_committee)

= render 'shared/alerts'

.row
  - if session['permitted_trials'].blank?
    - unless current_user.present?
      .col-md-6.col-lg-4
        .ls20.hidden-md-up
        .container
          .jumbotron
            %h1.display-4= @committee.name
            %p.lead
              = t(:commitee_lead_text)
              = link_to t(:sign_in), '/auth/sso'
            %hr.my-4/
            %p.lead
              = link_to t(:new_trial), new_committee_trial_path(@committee),
              class: 'btn btn-lg btn-success'
  - else
    .col-md-6.col-lg-4
      .ls20.hidden-md-up
      %h3= t(:my_trials)
      = link_to t(:clear_from_this_computer),
      committee_trial_clear_permitted_path(@committee), method: :delete,
      class: 'btn btn-sm btn-secondary'
      .ls20
      .container
        %ul.list-group
          - session['permitted_trials'].each do |private_key_digest|
            - trial = Trial.find_by(private_key_digest: private_key_digest,
            committee: @committee)
            - unless trial.nil?
              %li.list-group-item= link_to trial.title, [@committee, trial]
  .col-md-6.col-lg-4
    .ls40.hidden-md-up
    %h2= t(:summary)
    %hr
    %h4= t(:number_of_trials, trials_count: @committee.trials.count,
    pending_count: @committee.trials.pending.count)
    .ls20
    = pie_chart @state_trial_count.map { |s| [s['name'], s['count']] }.to_h,
    colors: @state_trial_count.map { |s| "##{s['color']}" }
  .col-md-6.col-lg-4
    .ls40.hidden-md-up
    %h2= t(:meetings).capitalize
    %ul.list-group
      - @committee.formsub_committee.meetings.each do |meeting|
        %li.menu-flex-box
          %b= meeting.name
          :plain
            :
            #{l(Time.zone.parse(meeting.time_start), format: :day_month)}
            #{l(Time.zone.parse(meeting.time_start), format: :time)}
            -
            #{l(Time.zone.parse(meeting.time_end), format: :time)}
          .btn-group.ml-auto
            - if current_user.present?
              = link_to formsub_meeting_show(meeting.id),
              class: 'btn btn-outline-info btn-sm',
              title: t(:registrations_show), 'data-toggle': 'tooltip',
              'data-placement': 'bottom' do
                %i.fa.fa-eye
                %span.hidden-sm-up= t(:registrations_show)
            - unless session['permitted_trials'].blank?
              = link_to formsub_meetings_url,
              class: 'btn btn-sm btn-outline-success',
              title: t(:registrations), 'data-toggle': 'tooltip',
              'data-placement': 'bottom' do
                %i.fa.fa-plus-square-o
                %span.hidden-sm-up= t(:registrations)
      - if @committee.formsub_committee.meetings.blank?
        = t(:no_committee_meeting)
    .ls20
    - if @committee.info.present?
      %h2= t(:committee_info)
      .ls20
      = sanitize_trix_html @committee.info
  - if current_user.present?
    .col-md-6.col-lg-4
      .ls40.hidden-md-up
      %h2= t(:recent_activity)
      - @committee.comments.last(5).reverse.each do |comment|
        :plain
          #{l(comment.created_at, format: :long)}
          #{comment.user&.email || t(:candidate) + ':' unless \
          comment.title == 'history'}
          #{comment.comment.truncate(150)}
          (#{comment.commentable.title})
        %i= link_to t(:open_braces), committee_trial_path(@committee,
        comment.commentable, anchor: 'comments')
        %hr